﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Speech;
using System.Speech.Synthesis;
using WMPLib;
using System.Media;
using System.IO;

namespace Actions
{
    public class GeneralActions
    {
        #region Speech Actions
        static SpeechSynthesizer syn = new SpeechSynthesizer();
        static Queue<string> speakQ = new Queue<string>();//todo make a queue of speech objects so we can free up threads from waiting on speaking commands => more responsive to "barge in"

        static public void Speak(string words)
        {
            syn.Speak(words);
        }

        static public void SpeakAsync(string words)
        {
            syn.SpeakAsync(words);
        }

        static public void Goodbye(string name)
        {
            syn.Speak("Goodbye " + name + ". It was my pleasure to serve you.");
        }

        static public void Greet(string name)
        {
            string greet = "Hello ";
            int hour = DateTime.Now.TimeOfDay.Hours;
            if (hour < 12)
            {
                greet = "Good morning ";
            }
            else if (hour < 17)
            {
                greet = "Good afternoon ";
            }
            else
            {
                greet = "Good evening ";
            }

            syn.Speak(greet + name + ".");
        }

        static public void SayTime()
        {
            string text = "";
            string end = "";
            string str_hour = "";
            int hour = DateTime.Now.TimeOfDay.Hours;
            //todo: refine this model to be more robust
            if (hour > 12)
            {
                str_hour = (hour - 12).ToString();
                end = "P M";
            }
            else
            {
                str_hour = hour.ToString();
                end = "A M";
            }
            int minutes = DateTime.Now.TimeOfDay.Minutes;
            if (minutes < 31)
            {
                //minutes less than 31 => express as minutes after
                text = "The time is " + minutes.ToString() + " minutes after " + str_hour + " " + end;
            }
            else
            {
                //minutes greater than 30 => express as minutes until
                minutes = 60 - minutes;
                hour++;
                if (hour == 24)
                {
                    //it is about to be midnight
                    str_hour = "midnight";
                    end = "";
                }
                else if (hour ==12)
                {
                    str_hour = "noon";
                    end = "";
                }
                else
                {
                    str_hour = hour.ToString();
                    if (hour < 12)
                    {
                        end = "A M";
                    }
                    else
                    {
                        end = "P M";
                    }
                }
                text = "There are " + minutes + " minutes until " + str_hour + end;
            }
            Actions.GeneralActions.Speak(text);
        }
        #endregion

        #region Application Actions
        static public void StartWMP(string filepath)
        {
            WMPLib.WindowsMediaPlayer wmp = new WindowsMediaPlayer();
            wmp.URL = filepath;
            wmp.controls.play();
        }
        static public void StartDefaultAudioPlayer(string filepath)
        {
            System.Diagnostics.Process.Start(filepath);
        }
        #endregion

    }
}
