﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LilyNUI
{
    public class Person
    {
        public enum Gender
        {
            Unknown = 0,
            Female,
            Male
        }

        private DateTime lastGreeted;
        public DateTime LastGreeted
        {
            get { return lastGreeted; }
            set { lastGreeted = value; }
        }

        private Guid personId;
        public Guid PersonId
        {
            get { return personId; }
        }

        private string rfid;
        public string Rfid
        {
            get { return rfid; }
            set { rfid = value; }
        }

        private Gender gender;
        public Gender PersonGender
        {
            get { return gender; }
            set { gender = value; }
        }

        private string full_name;
        public string Full_name
        {
            get { return full_name; }
            set { full_name = value; }
        }

        private string preferred_name;
        public string Preferred_name
        {
            get { return preferred_name; }
            set { preferred_name = value; }
        }

        private Histogram histogram;
        public Histogram Histogram
        {
            get { return histogram; }
            set { histogram = value; }
        }

        private string skeletonId;
        public string SkeletonId
        {
            get { return skeletonId; }
            set { skeletonId = value; }
        }

        public bool greetedToday()
        {
            if (this.lastGreeted.ToShortDateString() == DateTime.Now.ToShortDateString())
            {
                return true;
            }
            return false;
        }

        public override int GetHashCode()
        {
            return personId.GetHashCode();// base.GetHashCode();
        }

        public override bool Equals(object obj)
        {
            if (obj.GetType() != typeof(Person))
            {
                //obj is not a Person => cannot be equal
                return false;
            }
            //obj is of type Person => let's do the comparison
            Person other = (Person)obj;
            return ((this.Rfid == other.Rfid) && (this.Full_name == other.Full_name) && (this.Preferred_name== other.Preferred_name));
        }
        #region Constructors
        /// <summary>
        /// Public default constructor.
        /// </summary>
        public Person()
        {
            personId = Guid.NewGuid();
        }

        public Person(string rfid,
                      Gender gend,
                      string fullname,
                      string preferredName)
        {
            this.gender = gend;
            this.rfid = rfid;
            this.full_name = fullname;
            this.preferred_name = preferredName;
            personId = Guid.NewGuid();
        }

        /// <summary>
        /// Constructor for Person object.
        /// </summary>
        /// <param name="id">[in] Guid that represents the Id of the person - unique identifier.</param>
        public Person(Guid id)
        {
            personId = id;
        }

        #endregion
    }
}
